//********************************
//**ScummVM Quick And Easy 1.4.0**
//**By Ben Gorman (Bgbennyboy)****
//**Http://quick.mixnmojo.com/****
//********************************

unit Editor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, INIFiles, jclstrings, ExtCtrls, htmcombo, jclinifiles;

type
  TEditfrm = class(TForm)
    editLongname: TEdit;
    editTarget: TEdit;
    lblLongname: TLabel;
    lblTarget: TLabel;
    lblIsDemo: TLabel;
    imgIsDemo: TImage;
    lblBootParams: TLabel;
    lbllanguage: TLabel;
    comboboxlanguage: THTMLComboBox;
    comboboxbootparams: THTMLComboBox;
    lblGametype: TLabel;
    comboboxGameType: THTMLComboBox;
    lblgame: TLabel;
    comboboxeditgame: THTMLComboBox;
    comboboxCompatibility: THTMLComboBox;
    lblCompatibility: TLabel;
    lblNoPrompt: TLabel;
    imgNoPrompt: TImage;
    btnSave: TButton;
    btnDiscardChanges: TButton;
    btnRestoreOriginal: TButton;
    procedure lblLongnameMouseEnter(Sender: TObject);
    procedure lblLongnameMouseLeave(Sender: TObject);
    procedure lblTargetMouseEnter(Sender: TObject);
    procedure lblTargetMouseLeave(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure lblIsDemoMouseEnter(Sender: TObject);
    procedure lblIsDemoMouseLeave(Sender: TObject);
    procedure comboboxeditgameDropDown(Sender: TObject);
    procedure comboboxeditgameChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure lblIsDemoClick(Sender: TObject);
    procedure lblNoPromptMouseEnter(Sender: TObject);
    procedure lblNoPromptMouseLeave(Sender: TObject);
    procedure lblNoPromptClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure btnDiscardChangesClick(Sender: TObject);
    procedure editLongnameChange(Sender: TObject);
    procedure editTargetChange(Sender: TObject);
    procedure comboboxGameTypeChange(Sender: TObject);
    procedure comboboxCompatibilityChange(Sender: TObject);
    procedure comboboxbootparamsChange(Sender: TObject);
    procedure comboboxlanguageChange(Sender: TObject);
    procedure lblGametypeMouseEnter(Sender: TObject);
    procedure lblGametypeMouseLeave(Sender: TObject);
    procedure lblCompatibilityMouseEnter(Sender: TObject);
    procedure lblCompatibilityMouseLeave(Sender: TObject);
    procedure lblBootParamsMouseEnter(Sender: TObject);
    procedure lblBootParamsMouseLeave(Sender: TObject);
    procedure lbllanguageMouseEnter(Sender: TObject);
    procedure lbllanguageMouseLeave(Sender: TObject);
    procedure lblLongnameClick(Sender: TObject);
    procedure lblGametypeClick(Sender: TObject);
    procedure lblCompatibilityClick(Sender: TObject);
    procedure lblBootParamsClick(Sender: TObject);
    procedure lbllanguageClick(Sender: TObject);
    procedure btnRestoreOriginalClick(Sender: TObject);
  private
    procedure Storevalues;
    procedure StoreNewValues;
    procedure MakeIniBackup;
    procedure ClearAll;
    procedure LoadGameSettings;
    procedure SaveGameSettings;
    function CheckChanged: boolean;
    function CheckNEWValues: boolean;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Editfrm: TEditfrm;
  origlongname, origtarget, orig2longname, orig2target: string;
  origgametype, origcompatibility, origbootparam, origlanguage, origisdemo: integer;
  orig2gametype, orig2compatibility, orig2bootparam, orig2language, orig2isdemo: integer;
  alreadysaved: boolean;

implementation

uses ScummVMQandE;

{$R *.dfm}

//Check Changed
function TEditfrm.CheckChanged: boolean; //if its changed is true
begin
  result:=false;

  if origlongname <> editLongname.Text then
    result:=true;
  if origtarget <> editTarget.Text then
    result:=true;
  if origgametype <> comboboxGameType.ItemIndex then
    result:=true;
  if origcompatibility <> comboboxCompatibility.ItemIndex then
    result:=true;
  if origbootparam <> comboboxbootparams.ItemIndex then
    result:=true;
  if origlanguage <> comboboxlanguage.ItemIndex then
    result:=true;
  if origisdemo <> imgisdemo.Tag then
    result:=true;

  if alreadysaved=true then //check it with the orig2 values to see if its changed
  begin
    if CheckNEWValues=true then //its changed
    begin
      btnSave.Enabled:=true;
      result:=true;
    end
    else
    begin
      btnSave.Enabled:=false;
      result:=false;
    end
  end
  else
  if result=true then
  begin
    btnSave.Enabled:=true;
  end
  else
  begin
    btnSave.Enabled:=false;
  end;
end;

function TEditfrm.CheckNEWValues;
begin
  result:=false;

  if orig2longname <> editLongname.Text then
    result:=true;
  if orig2target <> editTarget.Text then
    result:=true;
  if orig2gametype <> comboboxGameType.ItemIndex then
    result:=true;
  if orig2compatibility <> comboboxCompatibility.ItemIndex then
    result:=true;
  if orig2bootparam <> comboboxbootparams.ItemIndex then
    result:=true;
  if orig2language <> comboboxlanguage.ItemIndex then
    result:=true;
  if orig2isdemo <> imgisdemo.Tag then
    result:=true;
end;

//Store Values
procedure TEditfrm.StoreValues;
begin
  origlongname:=editLongname.Text;
  origtarget:=editTarget.Text;
  origgametype:=comboboxGameType.ItemIndex;
  origcompatibility:=comboboxCompatibility.ItemIndex;
  origbootparam:=comboboxbootparams.itemindex;
  origlanguage:=comboboxlanguage.ItemIndex;
  origisdemo:=imgIsDemo.Tag;
end;

//Store NEW Values
procedure TEditfrm.StoreNewValues;
begin
  orig2longname:=editLongname.Text;
  orig2target:=editTarget.Text;
  orig2gametype:=comboboxGameType.ItemIndex;
  orig2compatibility:=comboboxCompatibility.ItemIndex;
  orig2bootparam:=comboboxbootparams.itemindex;
  orig2language:=comboboxlanguage.ItemIndex;
  orig2isdemo:=imgIsDemo.Tag;
end;

//Edit Form Show
procedure TEditfrm.FormShow(Sender: TObject);
begin
  ClearAll;
  btnSave.Enabled:=false;
  btnDiscardChanges.Enabled:=false;
  MakeIniBackup;
  mainfrm.populategames(gf_all, comboboxeditgame);
  mainfrm.LoadGlyphsFromIni(comboboxeditgame);
  StoreValues;
end;

//Make Ini Backup
procedure TEditfrm.MakeIniBackup;
var
  sStream, dStream: TFileStream;
begin
  sStream := TFileStream.Create(ExtractFilePath(Application.ExeName) + 'ScummVMQ+E.ini', fmOpenRead);
  try
    dStream := TFileStream.Create(ExtractFilePath(Application.ExeName) + 'BACKUPScummVMQ+E.ini', fmCreate);
    try
      dStream.CopyFrom(sStream, 0);
    finally
      dStream.Free;
    end;
  finally
    sStream.Free;
  end;
end;

//Clear All
procedure TEditfrm.ClearAll;
begin
  editTarget.Text:='';
  editLongname.Text:='';
  comboboxlanguage.ItemIndex:=0;
  comboboxGameType.ItemIndex:=0;
  comboboxbootparams.ItemIndex:=0;
  comboboxCompatibility.ItemIndex:=21;
  imgIsDemo.Tag:=0;
  imgIsDemo.Picture.Bitmap.LoadFromResourceName(0, 'CROSS');
  origlongname:='';
  origtarget:='';
  origgametype:=0;
  origcompatibility:=21;
  origbootparam:=0;
  origlanguage:=0;
  origisdemo:=0;
  orig2longname:='';
  orig2target:='';
  orig2gametype:=0;
  orig2compatibility:=21;
  orig2bootparam:=0;
  orig2language:=0;
  orig2isdemo:=0;
end;

//Load Game Settings
procedure TEditfrm.LoadGameSettings;
var
  QEIni: Tmeminifile;
  tempstr: string;
begin
  QEIni:=TmemIniFile.Create(ExtractFilePath(Application.ExeName) + 'ScummVMQ+E.ini');
  try
    tempstr:=strafter(comboboxeditgame.TextItems[comboboxeditgame.itemindex] , comboboxeditgame.Items.Strings[comboboxeditgame.itemindex]);
    editTarget.Text:=copy(tempstr, 5, length(tempstr)-7);

    editLongname.Text:=QEini.ReadString(editTarget.Text, 'Longname', '');

    if QEini.ReadString(editTarget.Text, 'Gametype', '')='SCUMM' then comboboxgametype.ItemIndex:=0
    else
    if QEini.ReadString(editTarget.Text, 'Gametype', '')='Humongous' then comboboxgametype.ItemIndex:=1
    else
    if QEini.ReadString(editTarget.Text, 'Gametype', '')='Revolution' then comboboxgametype.ItemIndex:=2
    else
    if QEini.ReadString(editTarget.Text, 'Gametype', '')='Other' then comboboxgametype.ItemIndex:=3
    else
    comboboxgametype.ItemIndex:=3; //if no gametype then its Other

    comboboxCompatibility.ItemIndex:=QEini.ReadInteger(editTarget.Text, 'Compatibility', 21); 

    if QEini.ReadString(editTarget.Text, 'BootParamType', '')='Sword1' then comboboxbootparams.ItemIndex:=1
    else
    if QEini.ReadString(editTarget.Text, 'BootParamType', '')='DOTT' then comboboxbootparams.ItemIndex:=2
    else
    if QEini.ReadString(editTarget.Text, 'BootParamType', '')='FT' then comboboxbootparams.ItemIndex:=3
    else
    if QEini.ReadString(editTarget.Text, 'BootParamType', '')='FTDosDemo' then comboboxbootparams.ItemIndex:=4
    else
    if QEini.ReadString(editTarget.Text, 'BootParamType', '')='FOA' then comboboxbootparams.ItemIndex:=5
    else
    if QEini.ReadString(editTarget.Text, 'BootParamType', '')='LoomFMTowns' then comboboxbootparams.ItemIndex:=6
    else
    if QEini.ReadString(editTarget.Text, 'BootParamType', '')='MI1' then comboboxbootparams.ItemIndex:=7
    else
    if QEini.ReadString(editTarget.Text, 'BootParamType', '')='MI2' then comboboxbootparams.ItemIndex:=8
    else
    if QEini.ReadString(editTarget.Text, 'BootParamType', '')='MI2Demo' then comboboxbootparams.ItemIndex:=9
    else
    if QEini.ReadString(editTarget.Text, 'BootParamType', '')='CMI' then comboboxbootparams.ItemIndex:=10
    else
    if QEini.ReadString(editTarget.Text, 'BootParamType', '')='SamAndMax' then comboboxbootparams.ItemIndex:=11
    else
    if QEini.ReadString(editTarget.Text, 'BootParamType', '')='SamAndMaxMacDemo' then comboboxbootparams.ItemIndex:=12
    else
    if QEini.ReadString(editTarget.Text, 'BootParamType', '')='DigDemo' then comboboxbootparams.ItemIndex:=13
    else
    comboboxbootparams.ItemIndex:=0;

    if QEini.ReadString(editTarget.Text, 'LanguageType', '')='Sky' then comboboxlanguage.ItemIndex:=1
    else
    if QEini.ReadString(editTarget.Text, 'LanguageType', '')='Sword1' then comboboxlanguage.ItemIndex:=2
    else
    if QEini.ReadString(editTarget.Text, 'LanguageType', '')='Maniac' then comboboxlanguage.ItemIndex:=3
    else
    if QEini.ReadString(editTarget.Text, 'LanguageType', '')='CMI' then comboboxlanguage.ItemIndex:=4
    else
    if QEini.ReadString(editTarget.Text, 'LanguageType', '')='Simon' then comboboxlanguage.ItemIndex:=5
    else
    if QEini.ReadString(editTarget.Text, 'LanguageType', '')='Dig' then comboboxlanguage.ItemIndex:=6
    else
    comboboxlanguage.ItemIndex:=0;

    if QEIni.ReadBool(editTarget.Text, 'IsDemo', false)=true then
    begin
      imgIsDemo.Picture.Bitmap.LoadFromResourceName(0, 'TICK');
      imgIsDemo.Tag:=1;
    end
    else
    begin
      imgIsDemo.Picture.Bitmap.LoadFromResourceName(0, 'CROSS');
      imgIsDemo.Tag:=0;
    end;

  finally
    QEIni.Free;
  end;
end;

//Save Game Settings
procedure TEditfrm.SaveGameSettings;
var
  QEIni: Tmeminifile;
  strings, commentstrings: tstringlist;
  i, commentcount: Integer;
begin
  btnDiscardChanges.Enabled:=true;
  btnSave.Enabled:=false;

  QEIni:=TmemIniFile.Create(ExtractFilePath(Application.ExeName) + 'ScummVMQ+E.ini');
  strings:=tstringlist.Create;
  commentstrings:=tstringlist.Create;
  try
    QEIni.WriteString(editTarget.Text, 'longname', editLongname.Text);   //update game in combobox too

    case comboboxGameType.ItemIndex of
     -1: QEIni.WriteString(editTarget.Text, 'gametype', 'Other'); //shouldnt ever happen
      0: QEIni.WriteString(editTarget.Text, 'gametype', 'SCUMM');
      1: QEIni.WriteString(editTarget.Text, 'gametype', 'Humongous');
      2: QEIni.WriteString(editTarget.Text, 'gametype', 'Revolution');
      3: QEIni.WriteString(editTarget.Text, 'gametype', 'Other');
    end;

    if comboboxCompatibility.ItemIndex=-1 then
      QEIni.WriteInteger(editTarget.Text, 'compatibility', 21)
    else
      QEIni.WriteInteger(editTarget.Text, 'compatibility', comboboxCompatibility.ItemIndex);

    case comboboxbootparams.itemindex of
     -1: QEIni.WriteString(editTarget.Text, 'bootparamtype', '');
      0: QEIni.WriteString(editTarget.Text, 'bootparamtype', '');
      1: QEIni.WriteString(editTarget.Text, 'bootparamtype', 'Sword1');
      2: QEIni.WriteString(editTarget.Text, 'bootparamtype', 'DOTT');
      3: QEIni.WriteString(editTarget.Text, 'bootparamtype', 'FT');
      4: QEIni.WriteString(editTarget.Text, 'bootparamtype', 'FTDosDemo');
      5: QEIni.WriteString(editTarget.Text, 'bootparamtype', 'FOA');
      6: QEIni.WriteString(editTarget.Text, 'bootparamtype', 'LoomFMTowns');
      7: QEIni.WriteString(editTarget.Text, 'bootparamtype', 'MI1');
      8: QEIni.WriteString(editTarget.Text, 'bootparamtype', 'MI2');
      9: QEIni.WriteString(editTarget.Text, 'bootparamtype', 'MI2Demo');
     10: QEIni.WriteString(editTarget.Text, 'bootparamtype', 'CMI');
     11: QEIni.WriteString(editTarget.Text, 'bootparamtype', 'SamAndMax');
     12: QEIni.WriteString(editTarget.Text, 'bootparamtype', 'SamAndMaxMacDemo');
     13: QEIni.WriteString(editTarget.Text, 'bootparamtype', 'DigDemo');
    end;

    case comboboxlanguage.ItemIndex of
     -1: QEIni.WriteString(editTarget.Text, 'languagetype', '');
      0: QEIni.WriteString(editTarget.Text, 'languagetype', '');
      1: QEIni.WriteString(editTarget.Text, 'languagetype', 'Sky');
      2: QEIni.WriteString(editTarget.Text, 'languagetype', 'Sword1');
      3: QEIni.WriteString(editTarget.Text, 'languagetype', 'Maniac');
      4: QEIni.WriteString(editTarget.Text, 'languagetype', 'CMI');
      5: QEIni.WriteString(editTarget.Text, 'languagetype', 'Simon');
      6: QEIni.WriteString(editTarget.Text, 'languagetype', 'Dig');
    end;

    case imgIsDemo.Tag of
      0: QEIni.WriteBool(editTarget.Text, 'IsDemo', false);
      1: QEIni.WriteBool(editTarget.Text, 'IsDemo', true);
    end;

    commentstrings.LoadFromFile(extractfilePath(Application.ExeName) + 'ScummVMQ+E.ini');
    commentcount:=0;

    QEini.getStrings(strings);
    for I := 0 to commentstrings.Count - 1 do
    begin
      if copy(commentstrings[i], 0, 1)=';' then
      begin
        strings.Insert(commentcount, commentstrings[i]);
        inc(commentcount);
      end;
    end;
    strings.Insert(commentcount, #13); //add a blank line between comments and settings

    Strings.SaveToFile(extractfilePath(Application.ExeName) + 'ScummVMQ+E.ini');
    //QEIni.UpdateFile;
  finally
    QEini.Free;
    strings.Free;
    commentstrings.Free;
    alreadysaved:=true;
    btnDiscardChanges.Enabled:=true;
    StoreNewValues;
  end;

end;

//Combobox Edit Game Dropdown
procedure TEditfrm.comboboxeditgameDropDown(Sender: TObject);
var
  i, itemwidth: Integer;
begin
  itemwidth:=0;
  comboboxeditgame.DropWidth:=1;

  for I := 0 to comboboxeditgame.Items.Count - 1 do
    if editfrm.Canvas.TextWidth(comboboxeditgame.TextItems[i])  > ItemWidth then
      ItemWidth := editfrm.Canvas.TextWidth(comboboxeditgame.textitems[i]) + 30;

  comboboxeditgame.DropWidth:=itemwidth;
end;

//Combobox Edit Game Change
procedure TEditfrm.comboboxeditgameChange(Sender: TObject);
begin
  if imgNoPrompt.Tag=0 then
  begin
    if (CheckChanged=true) then
      if messagedlg('There are unsaved changes. Save them?', mtConfirmation, [mbYes, mbNo], 0)=mryes then
        SaveGameSettings;
  end
  else
  if imgNoPrompt.Tag=1 then
    SaveGameSettings;

  ClearAll;
  LoadGameSettings;
  StoreValues;

  btnSave.Enabled:=false;
  alreadysaved:=false;
end;

//Edit Form Close
procedure TEditfrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if imgNoPrompt.Tag=0 then
  begin
    if CheckChanged=true then
      if messagedlg('There are unsaved changes. Save them?', mtConfirmation, [mbYes, mbNo], 0)=mryes then
      begin
        SaveGameSettings;
        close;
      end;
  end
  else
  if imgNoPrompt.Tag=1 then
    SaveGameSettings;
end;

procedure TEditfrm.lblIsDemoClick(Sender: TObject);
begin
  if imgIsDemo.Tag=1 then
  begin
    imgIsDemo.Picture.Bitmap.LoadFromResourceName(0,'CROSS');
    imgIsDemo.Tag:=0;
    imgIsDemo.Picture.Bitmap.FreeImage;
  end
  else
  begin
    imgIsDemo.Picture.Bitmap.LoadFromResourceName(0,'TICK');
    imgIsDemo.Tag:=1;
    imgIsDemo.Picture.Bitmap.FreeImage;
  end;

  CheckChanged;
end;

procedure TEditfrm.lblNoPromptMouseEnter(Sender: TObject);
begin
  lblNoPrompt.Font.style:=[fsunderline];
end;

procedure TEditfrm.lblNoPromptMouseLeave(Sender: TObject);
begin
  lblNoPrompt.Font.Style:=[];
end;

procedure TEditfrm.lblNoPromptClick(Sender: TObject);
begin
  if imgNoPrompt.Tag=1 then
  begin
    imgNoPrompt.Picture.Bitmap.LoadFromResourceName(0,'CROSS');
    imgNoPrompt.Tag:=0;
    imgNoPrompt.Picture.Bitmap.FreeImage;
  end
  else
  begin
    imgNoPrompt.Picture.Bitmap.LoadFromResourceName(0,'TICK');
    imgNoPrompt.Tag:=1;
    imgNoPrompt.Picture.Bitmap.FreeImage;
  end;
end;

//Button Save Click
procedure TEditfrm.btnSaveClick(Sender: TObject);
begin
  SaveGameSettings;
end;

//Button Discard Changes Click
procedure TEditfrm.btnDiscardChangesClick(Sender: TObject);
begin
  if messagedlg('Do you want to undo ALL saved and unsaved changes?', mtConfirmation, [mbYes, mbNo], 0)=mryes then
  begin
    deletefile(ExtractFilePath(Application.ExeName) + 'ScummVMQ+E.ini');
    renamefile(ExtractFilePath(Application.ExeName) + 'BACKUPScummVMQ+E.ini', ExtractFilePath(Application.ExeName) + 'ScummVMQ+E.ini');
    MakeIniBackup;
    btnDiscardChanges.Enabled:=false;
    ClearAll;
    mainfrm.populategames(gf_all, comboboxeditgame);
    mainfrm.LoadGlyphsFromIni(comboboxeditgame);
    StoreValues;
    btnSave.Enabled:=false;
  end
  else
    //do nothing
end;

procedure TEditfrm.editLongnameChange(Sender: TObject);
begin
  CheckChanged;
end;

procedure TEditfrm.editTargetChange(Sender: TObject);
begin
  CheckChanged;
end;

procedure TEditfrm.comboboxGameTypeChange(Sender: TObject);
begin
  CheckChanged;
end;

procedure TEditfrm.comboboxCompatibilityChange(Sender: TObject);
begin
  CheckChanged;
end;

procedure TEditfrm.comboboxbootparamsChange(Sender: TObject);
begin
  CheckChanged;
end;

procedure TEditfrm.comboboxlanguageChange(Sender: TObject);
begin
  CheckChanged;
end;

procedure TEditfrm.lblGametypeMouseEnter(Sender: TObject);
begin
  lblGametype.Font.Style:=[fsunderline];
end;

procedure TEditfrm.lblGametypeMouseLeave(Sender: TObject);
begin
  lblGametype.Font.Style:=[];
end;

procedure TEditfrm.lblCompatibilityMouseEnter(Sender: TObject);
begin
  lblCompatibility.Font.Style:=[fsunderline];
end;

procedure TEditfrm.lblCompatibilityMouseLeave(Sender: TObject);
begin
  lblCompatibility.Font.Style:=[];
end;

procedure TEditfrm.lblBootParamsMouseEnter(Sender: TObject);
begin
  lblBootParams.Font.Style:=[fsunderline];
end;

procedure TEditfrm.lblBootParamsMouseLeave(Sender: TObject);
begin
  lblBootParams.Font.Style:=[];
end;

procedure TEditfrm.lbllanguageMouseEnter(Sender: TObject);
begin
  lbllanguage.Font.Style:=[fsunderline];
end;

procedure TEditfrm.lbllanguageMouseLeave(Sender: TObject);
begin
  lbllanguage.Font.Style:=[];
end;

procedure TEditfrm.lblLongnameClick(Sender: TObject);
begin
  editLongname.Text:=origlongname;
end;

procedure TEditfrm.lblGametypeClick(Sender: TObject);
begin
  comboboxGameType.ItemIndex:=origgametype;
end;

procedure TEditfrm.lblCompatibilityClick(Sender: TObject);
begin
  comboboxCompatibility.ItemIndex:=origcompatibility;
end;

procedure TEditfrm.lblBootParamsClick(Sender: TObject);
begin
  comboboxbootparams.ItemIndex:=origbootparam;
end;

procedure TEditfrm.lbllanguageClick(Sender: TObject);
begin
  comboboxlanguage.ItemIndex:=origlanguage;
end;

procedure TEditfrm.lblLongnameMouseEnter(Sender: TObject);
begin
  lblLongName.Font.Style:=[fsunderline]
end;

procedure TEditfrm.lblLongnameMouseLeave(Sender: TObject);
begin
  lblLongName.Font.Style:=[];
end;

procedure TEditfrm.lblTargetMouseEnter(Sender: TObject);
begin
  lblTarget.Font.Style:=[fsunderline];
end;

procedure TEditfrm.lblTargetMouseLeave(Sender: TObject);
begin
  lblTarget.Font.style:=[];
end;

procedure TEditfrm.lblIsDemoMouseEnter(Sender: TObject);
begin
  lblIsDemo.Font.style:=[fsunderline]
end;

procedure TEditfrm.lblIsDemoMouseLeave(Sender: TObject);
begin
  lblIsDemo.Font.style:=[];
end;

procedure TEditfrm.btnRestoreOriginalClick(Sender: TObject);
var
  res: tresourcestream;
begin
  if messagedlg('This will erase ALL game changes ever made and will restore the default ScummVMQ+E.ini' + #13 + 'Are you sure you want to continue?', mtConfirmation, [mbYes, mbNo], 0)=mryes then
  begin
    res:=TResourceStream.Create(0, 'INI', 'TEXT');
    try
      try
        res.SaveToFile(extractfilepath(application.ExeName) + 'ScummVMQ+E.ini');
      except on efcreateerror do
        showmessage('Could not find or create ScummVMQ+E.ini ' + #13 + 'It is possible that you are running from a read-only location, like a cd :~');
      end;
    finally
      res.Free;
    end;
  end
  else

end;

end.
