//********************************
//**ScummVM Quick And Easy 1.4.0**
//**By Ben Gorman (Bgbennyboy)****  //Change text to 'ENCODING' when encoding as well as locking form
//**Http://quick.mixnmojo.com/****              
//********************************

unit ExtraTools;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, JvExComCtrls, JvComCtrls, Mask, JvExMask,
  JvMaskEdit, JvSpin, jclshell, jclfileutils, jclstrings;

type
  Ttoolsfrm = class(TForm)
    comboboxTools: TComboBox;
    groupboxCompressAudio: TGroupBox;
    spineditABR: TJvSpinEdit;
    comboboxCompressor: TComboBox;
    comboboxMode: TComboBox;
    btnGo: TButton;
    lblCompressor: TLabel;
    lblMode: TLabel;
    lblABR: TLabel;
    lblVBRmin: TLabel;
    lblVBRmax: TLabel;
    lblVBRquality: TLabel;
    lblMPEGquality: TLabel;
    btnDefaults: TButton;
    OpenDialog1: TOpenDialog;
    comboboxVBRmin: TComboBox;
    comboboxVBRmax: TComboBox;
    comboboxMPEGquality: TComboBox;
    comboboxVBRquality: TComboBox;
    editFLAC: TEdit;
    lblCommandLine: TLabel;
    procedure comboboxToolsChange(Sender: TObject);
    procedure comboboxModeChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnDefaultsClick(Sender: TObject);
    procedure btnGoClick(Sender: TObject);
    procedure comboboxCompressorChange(Sender: TObject);
    procedure comboboxVBRminExit(Sender: TObject);
    procedure comboboxVBRmaxExit(Sender: TObject);
  private
    procedure DoSOUdefaults;
    procedure LoadMP3Defaults;
    procedure LoadVorbisDefaults;
    procedure LoadFLACDefaults;
    function GetParams: string;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  toolsfrm: Ttoolsfrm;

implementation

uses ScummVMQandE;

{$R *.dfm}

procedure Ttoolsfrm.DoSOUdefaults;
begin
  ComboBoxCompressor.ItemIndex:=0;
  ComboboxMode.ItemIndex:=0;
  Comboboxmode.OnChange(comboboxmode);
end;

procedure TToolsfrm.LoadMP3Defaults;
const
  VBRbitrateStrings: array [0..13] of string=('8','16', '24', '32', '40', '48', '56', '64', '80', '96', '112', '128', '144', '160');
var
  I: Integer;
begin
  spineditABR.MaxValue:=310;
  spineditABR.MinValue:=4;
  spineditABR.Hint:='Min=4 Max=310 (Default=256)';
  spineditABR.Value:=256;
  spineditABR.visible:=true;
  lblABR.visible:=true;

  comboboxVBRmin.Clear;
  for I := 0 to high(VBRbitrateStrings) do
    comboboxVBRmin.Items.Add(VBRbitrateStrings[i]);
  comboboxVBRmin.ItemIndex:=2;
  comboboxVBRmin.Hint:='Min=8 Max=160 (Default=24)';

  comboboxVBRmax.Clear;
  for I := 0 to high(VBRbitrateStrings) do
    comboboxVBRmax.Items.Add(VBRbitrateStrings[i]);
  comboboxVBRmax.ItemIndex:=2;
  comboboxVBRmax.Hint:='Min=8 Max=160 (Default=24)';

  comboboxVBRquality.Clear;
  for I := 0 to 9 do
    comboboxVBRquality.Items.Add(inttostr(i));
  comboboxVBRquality.hint:='0=Best (Default=4)';
  comboboxVBRquality.ItemIndex:=4;
  lblVBRquality.Caption:='VBR Quality';
  lblVBRquality.Top:=168;
  comboboxVBRquality.Top:=184;

  comboboxMPEGquality.Clear;
  for I := 0 to 9 do
    comboboxMPEGquality.Items.Add(inttostr(i));
  comboboxMPEGquality.Itemindex:=2;
  comboboxMPEGquality.Hint:='0=Best (Default=2)';
  comboboxMPEGquality.visible:=true;
  lblMPEGquality.visible:=true;

  editFLAC.Visible:=false;
  lblCommandLine.Visible:=false;
  comboboxMode.Visible:=true;
  lblMode.Visible:=true;
  comboboxMode.ItemIndex:=0;
  comboboxMode.OnChange(toolsfrm);

  comboboxMode.Visible:=true;
  lblMode.Visible:=true;
  spineditABR.Visible:=true;
  lblABR.Visible:=true;
  comboboxVBRmin.Visible:=true;
  lblVBRmin.Visible:=true;
  comboboxVBRmax.Visible:=true;
  lblVBRmax.Visible:=true;
  comboboxVBRquality.Visible:=true;
  lblVBRquality.Visible:=true;
  comboboxMPEGquality.Visible:=true;
  lblMPEGquality.Visible:=true;
end;

procedure TToolsfrm.LoadVorbisDefaults;
const
  VBRbitrateStrings: array [0..14] of string=('None', '8','16', '24', '32', '40', '48', '56', '64', '80', '96', '112', '128', '144', '160');
var
  i: Integer;
begin
  comboboxVBRquality.Clear;
  for I := 0 to 10 do
    comboboxVBRquality.Items.Add(inttostr(i));
  comboboxVBRquality.hint:='10=Best (Default=3)';
  comboboxVBRquality.ItemIndex:=3;
  lblVBRquality.Caption:='Quality';
  lblVBRquality.Top:=120;
  comboboxVBRquality.Top:=136;

  comboboxVBRmin.Clear;
  for I := 0 to high(VBRbitrateStrings) do
    comboboxVBRmin.Items.Add(VBRbitrateStrings[i]);
  comboboxVBRmin.ItemIndex:=0;
  comboboxVBRmin.Hint:='Default=None';

  comboboxVBRmax.Clear;
  for I := 0 to high(VBRbitrateStrings) do
    comboboxVBRmax.Items.Add(VBRbitrateStrings[i]);
  comboboxVBRmax.ItemIndex:=0;
  comboboxVBRmax.Hint:='Default=None';

  comboboxMode.Visible:=false;
  lblMode.Visible:=false;
  comboboxMPEGquality.visible:=false;
  lblMPEGquality.visible:=false;
  spineditABR.visible:=false;
  lblABR.visible:=false;

  editFLAC.Visible:=false;
  lblCommandLine.Visible:=false;
  lblVBRmin.Enabled:=true;
  lblVBRmax.Enabled:=true;
  lblVBRquality.Enabled:=true;
  comboboxVBRmin.Enabled:=true;
  comboboxVBRmax.Enabled:=true;
  comboboxVBRquality.Enabled:=true;

  comboboxVBRmin.Visible:=true;
  lblVBRmin.Visible:=true;
  comboboxVBRmax.Visible:=true;
  lblVBRmax.Visible:=true;
  comboboxVBRquality.Visible:=true;
  lblVBRquality.Visible:=true;
end;

procedure TToolsfrm.LoadFLACDefaults;
begin
  editFLAC.Visible:=true;
  editFLAC.Left:=8;
  editFLAC.Top:=88;
  lblCommandLine.Visible:=true;
  lblCommandLine.Top:=72;
  lblCommandLine.Left:=8;

  comboboxMode.Visible:=false;
  lblMode.Visible:=false;
  spineditABR.Visible:=false;
  lblABR.Visible:=false;
  comboboxVBRmin.Visible:=false;
  lblVBRmin.Visible:=false;
  comboboxVBRmax.Visible:=false;
  lblVBRmax.Visible:=false;
  comboboxVBRquality.Visible:=false;
  lblVBRquality.Visible:=false;
  comboboxMPEGquality.Visible:=false;
  lblMPEGquality.Visible:=false;
end;


procedure Ttoolsfrm.comboboxToolsChange(Sender: TObject);
begin
  case ComboboxTools.ItemIndex of
    0:  begin
          groupboxCompressAudio.Caption:='Compress .sou files';
          OpenDialog1.Filter:='Monster.sou files|*.sou'
        end;
    1:  begin
          groupboxCompressAudio.Caption:='Compress Simon The Sorcerer 1+2 datafiles';
          OpenDialog1.Filter:='VOC + WAV files|*.voc;*.wav';
        end;
    2:  begin
          groupboxCompressAudio.Caption:='Compress SAGA engine sound files';
          OpenDialog1.Filter:='All files|*.*';
        end;
    3:  begin
          groupboxCompressAudio.Caption:='Compress Broken Sword 2 sound and music';
          OpenDialog1.Filter:='Clu files|*.clu;';
        end;
  end;


end;

procedure Ttoolsfrm.comboboxModeChange(Sender: TObject);
begin
  if comboboxCompressor.itemindex=0 then //mp3
  begin
    if Comboboxmode.ItemIndex=0 then
    begin
      lblabr.Enabled:=false;
      spineditABR.Enabled:=false;
      lblVBRmin.Enabled:=true;
      lblVBRmax.Enabled:=true;
      lblVBRquality.Enabled:=true;
      comboboxVBRmin.Enabled:=true;
      comboboxVBRmax.Enabled:=true;
      comboboxVBRquality.Enabled:=true;
    end
    else
    if Comboboxmode.ItemIndex=1 then
    begin
      lblabr.Enabled:=true;
      spineditABR.Enabled:=true;
      lblVBRmin.Enabled:=false;
      lblVBRmax.Enabled:=false;
      lblVBRquality.Enabled:=false;
      comboboxVBRmin.Enabled:=false;
      comboboxVBRmax.Enabled:=false;
      comboboxVBRquality.Enabled:=false;
    end;
  end
  else
  if comboboxCompressor.ItemIndex=1 then //vorbis
  begin
    //will never happen
  end
  else
  if comboboxCompressor.ItemIndex=2 then //flac
  begin
    //will never happen
  end;
    
    
end;

procedure Ttoolsfrm.FormCreate(Sender: TObject);
begin
  toolsfrm.Font.Name:=mainfrm.Font.Name;
  ComboBoxTools.ItemIndex:=0;
  ComboBoxTools.OnChange(comboboxTools);
end;

procedure Ttoolsfrm.btnDefaultsClick(Sender: TObject);
begin
  case comboboxCompressor.ItemIndex of
    0:  begin
          spineditABR.Value:=256;
          comboboxVBRmin.ItemIndex:=2;
          comboboxVBRmax.ItemIndex:=2;
          comboboxVBRquality.ItemIndex:=4;
          comboboxMPEGquality.Itemindex:=2;
          comboboxMode.ItemIndex:=0;
          comboboxMode.OnChange(btnDefaults)
        end;
    1:  begin
          comboboxVBRmin.ItemIndex:=0;
          comboboxVBRmax.ItemIndex:=0;
          comboboxVBRquality.ItemIndex:=3;
        end;
    2:  editFLAC.Text:='--best -b 1152 -f';
  end;


    
end;

procedure Ttoolsfrm.btnGoClick(Sender: TObject);
var
  batfile: tstringlist;
  DlgResult: TModalResult;
  fileext: string;
  toolname: string;
begin
  if comboboxTools.ItemIndex=0 then //compress SOU
  begin
    case comboboxCompressor.ItemIndex of
      0: fileext:='.so3';
      1: fileext:='.sog';
      2: fileext:='.sof';
    end;
    toolname:='compress_scumm_sou.exe';
  end
  else
  if comboboxTools.ItemIndex=1 then
  begin
    case comboboxCompressor.ItemIndex of
      0: fileext:='.mp3';
      1: fileext:='.ogg';
      2: fileext:='.fla';
    end;
    Toolname:='compress_simon.exe';
  end
  else
  if comboboxTools.ItemIndex=2 then
  begin
    case comboboxCompressor.ItemIndex of
      0: fileext:='.mp3';
      1: fileext:='.ogg';
      2: fileext:='.fla';
    end;
    Toolname:='compress_saga.exe';
  end
  else
  if comboboxTools.ItemIndex=3 then
  begin
    case comboboxCompressor.ItemIndex of
      0: fileext:='.cl3';
      1: fileext:='.clg';
      2: fileext:='.clf';
    end;
    Toolname:='compress_sword2.exe';
  end;

  if opendialog1.Execute then
  begin
    if fileexists(extractfilepath(application.exename) + '\tools\' + strbefore('.', extractfilename(opendialog1.filename)) + fileext) then
    begin
      DlgResult:=MessageDlg('A compressed ' + fileext + ' file already exists in the tools folder, if you continue it will be overwritten.' + #13 + 'Do you want to continue?' ,mtConfirmation,[mbOk,mbCancel],0);
      case DlgResult of
        mrOk: ;
        mrCancel: exit;
      end;
    end;

    batfile:=tstringlist.Create();
    try
      batfile.Add('@echo off');
      batfile.Add(extractfiledrive(extractfilepath(application.exename)));
      batfile.Add('cd ' + pathgetshortname(extractfilepath(application.exename) + '\tools\'));
      batfile.Add('@echo on');
      batfile.Add(Toolname + ' ' + getparams + ' ' + pathgetshortname(opendialog1.FileName));
      batfile.Add('@echo off');
      batfile.Add('if errorlevel 1 goto clean');
      batfile.Add('echo ******************************');
      batfile.Add('echo All Done!');
            batfile.Add('echo ******************************');

      if comboboxTools.ItemIndex=1 then //its simon
        batfile.Add('echo New file is ' + extractfilePath(opendialog1.FileName) + strbefore('.', extractfilename(opendialog1.filename)) + fileext)
      else
        batfile.Add('echo New file is ' + extractfilepath(application.exename) + '\tools\' + strbefore('.', extractfilename(opendialog1.filename)) + fileext);

      batfile.Add('echo Remember to move it to your game folder');
            batfile.Add('echo ******************************');
      batfile.Add('echo ScummVM Quick And Easy ' + inttostr(QEVersion)[1] + '.' + inttostr(QEVersion)[2] + '.' + inttostr(QEVersion) [3]);
            batfile.Add('echo ******************************');
      batfile.Add('goto end');
      batfile.Add(':clean');
      batfile.Add('echo Something went wrong!');
      batfile.Add(':end');
      batfile.Add('pause');

      batfile.SaveToFile(extractfilepath(application.exename) + 'SouCompress.bat');
    finally
      batfile.Free;
      mainfrm.EnableContainer(toolsfrm, false);
      //shellexec(0,'',extractfilepath(application.exename) + 'SouCompress.bat', '', extractfilepath(application.exename), SW_NORMAL);
      if shellexecandwait(extractfilepath(application.exename) + 'SouCompress.bat', '', '', SW_NORMAL)=true then
      
      else
        showmessage('Something went wrong!');

      if comboboxTools.ItemIndex=1 then //its simon
      begin
        if fileexists(extractfilePath(opendialog1.FileName) + strbefore('.', extractfilename(opendialog1.filename)) + fileext) then
          openfolder(extractfilePath(opendialog1.FileName));
      end
      else
      begin
        if fileexists(extractfilepath(application.exename) + '\tools\' + strbefore('.', extractfilename(opendialog1.filename)) + fileext) then
          openfolder(extractfilepath(application.exename) + '\tools\');
      end;

      mainfrm.EnableContainer(toolsfrm, true);
      if comboboxTools.ItemIndex=1 then //its simon
      begin
        deletefile(extractfilepath(opendialog1.FileName) + 'simon2.dat');
        deletefile(extractfilepath(opendialog1.FileName) + 'simon2.idx');
        deletefile(extractfilepath(application.exename) + '\tools\' + 'tempfile.raw');
        deletefile(extractfilepath(application.exename) + '\tools\' + 'tempfile.idx');
        deletefile(extractfilepath(application.exename) + '\tools\' + 'tempfile.mp3');
        deletefile(extractfilepath(application.exename) + '\tools\' + 'tempfile.ogg');
        deletefile(extractfilepath(application.exename) + '\tools\' + 'tempfile.fla');
        deletefile(extractfilepath(application.exename) + '\tools\' + 'tempfile.sb');
        deletefile(extractfilepath(application.exename) + '\tools\' + 'tempfile.tbl');
        deletefile(extractfilepath(application.exename) + '\tools\' + 'tempfile.dat');        
        deletefile(extractfilepath(application.exename) + 'SouCompress.bat');
      end
      else
      begin
        deletefile(extractfilepath(application.exename) + '\tools\' + 'tempfile.raw');
        deletefile(extractfilepath(application.exename) + '\tools\' + 'tempfile.idx');
        deletefile(extractfilepath(application.exename) + '\tools\' + 'tempfile.mp3');
        deletefile(extractfilepath(application.exename) + '\tools\' + 'tempfile.ogg');
        deletefile(extractfilepath(application.exename) + '\tools\' + 'tempfile.fla');
        deletefile(extractfilepath(application.exename) + '\tools\' + 'tempfile.sb');
        deletefile(extractfilepath(application.exename) + '\tools\' + 'tempfile.tbl');
        deletefile(extractfilepath(application.exename) + '\tools\' + 'tempfile.dat');
        deletefile(extractfilepath(application.exename) + 'SouCompress.bat');
      end;
    end;

  end;             

end;

function Ttoolsfrm.GetParams: string;
begin
  case comboboxCompressor.ItemIndex of
    0: result:='--mp3';
    1: result:='--vorbis';
    2: result:='--flac';
  end;

  if comboboxCompressor.ItemIndex=0 then
  begin
    if comboboxMode.ItemIndex=0 then
      result:=result + ' ' + '--vbr' + ' ' + '-b' + ' ' + comboboxVBRmin.text + ' ' + '-B' + ' ' + comboboxVBRmax.text + ' ' + '-V' + ' ' + comboboxVBRquality.Text
    else
    if comboboxMode.ItemIndex=1 then
      result:=result + ' ' + '--abr' + ' ' + '-b' + ' ' + inttostr(round(spineditABR.value));

    result:=result + ' ' + '-q' + ' ' + comboboxMPEGquality.Text;
  end
  else
  if comboboxCompressor.ItemIndex=1 then
  begin
    result:=result + ' ' + '-m' + ' ' + comboboxVBRmin.text + ' ' + '-M' + ' ' + comboboxVBRmax.text + ' ' + '-q' + ' ' + comboboxVBRquality.Text
  end
  else
  if comboboxCompressor.ItemIndex=2 then
  begin
    result:=result + ' ' + editFLAC.Text;
  end;

end;

procedure Ttoolsfrm.comboboxCompressorChange(Sender: TObject);
begin
  if comboboxCompressor.ItemIndex=0 then
    loadMP3defaults
  else
  if comboboxCompressor.ItemIndex=1 then
    LoadVorbisDefaults
  else
  if comboboxCompressor.ItemIndex=2 then
    LoadFLACDefaults;
end;

procedure Ttoolsfrm.comboboxVBRminExit(Sender: TObject);
begin
  if comboboxVBRmin.ItemIndex>comboboxVBRmax.ItemIndex then
    comboboxVBRmin.ItemIndex:=comboboxVBRMax.ItemIndex;
    
end;

procedure Ttoolsfrm.comboboxVBRmaxExit(Sender: TObject);
begin
  if comboboxVBRmax.ItemIndex<comboboxVBRmin.ItemIndex then
    comboboxVBRmax.ItemIndex:=comboboxVBRmin.ItemIndex;
end;

end.
