//********************************
//**ScummVM Quick And Easy 1.4.0**
//**By Ben Gorman (Bgbennyboy)****
//**Http://quick.mixnmojo.com/****
//********************************

unit Options;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, JvExStdCtrls, JvCombobox, ExtCtrls, htmcombo, JvExExtCtrls,
  JvBevel, JvBalloonHint, jclsysinfo, jclregistry, jclstrings, filectrl, jclinifiles,
  inifiles, JvColorCombo;

type
  TOptionsfrm = class(TForm)
    comboboxfont: TJvFontComboBox;
    lblFont: TLabel;
    lblDefault: TLabel;
    lblaspectratio: TLabel;
    imgAspectRatio: TImage;
    lblfullscreen: TLabel;
    imgFullscreen: TImage;
    lblsubtitles: TLabel;
    imgSubtitles: TImage;
    lblgraphicsfilter: TLabel;
    comboboxgraphics: THTMLComboBox;
    lblBalloonHint: TLabel;
    imgBalloonHint: TImage;
    lblBalloonHeader: TLabel;
    imgBalloonHeader: TImage;
    Bevel1: TBevel;
    lblGeneral: TLabel;
    Bevel2: TBevel;
    lblDisableHints: TLabel;
    imgDisableHints: TImage;
    lblSystemTray: TLabel;
    imgSystemTray: TImage;
    lblDisableSplash: TLabel;
    imgDisableSplash: TImage;
    editIniPath: TEdit;
    lblIniPath: TLabel;
    btnIniBrowse: TButton;
    lblSavePath: TLabel;
    editSavePath: TEdit;
    btnSavePath: TButton;
    lblPath: TLabel;
    Bevel3: TBevel;
    lblMinimize: TLabel;
    imgMinimize: TImage;
    lblHideWindow: TLabel;
    imgHideWindow: TImage;
    procedure comboboxfontChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lblFontMouseEnter(Sender: TObject);
    procedure lblFontMouseLeave(Sender: TObject);
    procedure lblFontClick(Sender: TObject);
    procedure lblaspectratioMouseEnter(Sender: TObject);
    procedure lblaspectratioMouseLeave(Sender: TObject);
    procedure lblaspectratioClick(Sender: TObject);
    procedure lblfullscreenClick(Sender: TObject);
    procedure lblfullscreenMouseEnter(Sender: TObject);
    procedure lblfullscreenMouseLeave(Sender: TObject);
    procedure lblsubtitlesClick(Sender: TObject);
    procedure lblsubtitlesMouseEnter(Sender: TObject);
    procedure lblsubtitlesMouseLeave(Sender: TObject);
    procedure lblDefaultMouseEnter(Sender: TObject);
    procedure lblDefaultMouseLeave(Sender: TObject);
    procedure JvBevel1MouseEnter(Sender: TObject);
    procedure JvBevel1MouseLeave(Sender: TObject);
    procedure lblBalloonHintMouseEnter(Sender: TObject);
    procedure lblBalloonHintMouseLeave(Sender: TObject);
    procedure lblBalloonHintClick(Sender: TObject);
    procedure lblBalloonHeaderMouseEnter(Sender: TObject);
    procedure lblBalloonHeaderMouseLeave(Sender: TObject);
    procedure lblBalloonHeaderClick(Sender: TObject);
    procedure lblDisableHintsMouseEnter(Sender: TObject);
    procedure lblDisableHintsMouseLeave(Sender: TObject);
    procedure lblDisableHintsClick(Sender: TObject);
    procedure lblSystemTrayMouseEnter(Sender: TObject);
    procedure lblSystemTrayMouseLeave(Sender: TObject);
    procedure lblSystemTrayClick(Sender: TObject);
    procedure lblDisableSplashMouseEnter(Sender: TObject);
    procedure lblDisableSplashMouseLeave(Sender: TObject);
    procedure lblDisableSplashClick(Sender: TObject);
    procedure lblDefaultClick(Sender: TObject);
    procedure comboboxgraphicsChange(Sender: TObject);
    procedure lblIniPathMouseEnter(Sender: TObject);
    procedure lblIniPathMouseLeave(Sender: TObject);
    procedure btnIniBrowseClick(Sender: TObject);
    procedure lblIniPathClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure lblSavePathMouseEnter(Sender: TObject);
    procedure lblSavePathMouseLeave(Sender: TObject);
    procedure lblSavePathClick(Sender: TObject);
    procedure btnSavePathClick(Sender: TObject);
    procedure lblPathMouseEnter(Sender: TObject);
    procedure lblPathMouseLeave(Sender: TObject);
    procedure lblPathClick(Sender: TObject);
    procedure lblMinimizeMouseEnter(Sender: TObject);
    procedure lblMinimizeMouseLeave(Sender: TObject);
    procedure lblMinimizeClick(Sender: TObject);
    procedure lblHideWindowMouseEnter(Sender: TObject);
    procedure lblHideWindowMouseLeave(Sender: TObject);
    procedure lblHideWindowClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Optionsfrm: TOptionsfrm;

implementation

uses ScummVMQandE, ExtraTools, Scheduler, Editor;

{$R *.dfm}

procedure TOptionsfrm.comboboxfontChange(Sender: TObject);
begin
  mainfrm.Font.Name:=comboboxfont.Fontname;
  toolsfrm.Font.Name:=comboboxfont.Fontname;
  optionsfrm.Font.Name:=comboboxfont.Fontname;
  editfrm.Font.Name:=comboboxfont.FontName;
  if assigned(tasksfrm) then tasksfrm.font.name:=comboboxfont.fontname;
  lblgeneral.Font.Name:=comboboxfont.Fontname;
  lblDefault.Font.Name:=comboboxfont.Fontname;
  regwritestring(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'font', comboboxfont.FontName);
end;

procedure TOptionsfrm.FormCreate(Sender: TObject);
begin
  comboboxfont.Sorted:=true;
  comboboxfont.FontName:=mainfrm.font.Name;

  //Balloon Hint  
  try
    if regreadinteger(HKEY_CURRENT_USER,'Software\Quick And Easy\ScummVM','balloonhint')=1 then
      begin
        imgBalloonHint.Picture.Bitmap.LoadFromResourceName(0, 'TICK');
        imgBalloonHint.Tag:=1;
        mainfrm.BalloonHint.UseBalloonAsApplicationHint:=true;
      end;
        Except On EJclRegistryError do
      begin
        imgBalloonHint.Picture.Bitmap.LoadFromResourceName(0, 'CROSS');
        imgBalloonHint.Tag:=0;
        mainfrm.BalloonHint.UseBalloonAsApplicationHint:=false;
      end;
  end;

  //Balloon Header
  try
    if regreadinteger(HKEY_CURRENT_USER,'Software\Quick And Easy\ScummVM','balloonheader')=1 then
      begin
        imgBalloonHeader.Picture.Bitmap.LoadFromResourceName(0, 'TICK');
        imgBalloonHeader.Tag:=1;
        mainfrm.BalloonHint.ApplicationHintOptions:=[ahShowHeaderInHint, ahShowIconInHint];
      end;
        Except On EJclRegistryError do 
      begin
        imgBalloonHeader.Picture.Bitmap.LoadFromResourceName(0, 'CROSS');
        imgBalloonHeader.Tag:=0;
        mainfrm.BalloonHint.ApplicationHintOptions:=[];
      end;
  end;

  //Disable Hints
  try
    if regreadinteger(HKEY_CURRENT_USER,'Software\Quick And Easy\ScummVM','disablehints')=1 then
      begin
        imgdisablehints.Picture.Bitmap.LoadFromResourceName(0, 'TICK');
        imgdisablehints.Tag:=1;
        optionsfrm.ShowHint:=false;
        mainfrm.ShowHint:=false;
        toolsfrm.ShowHint:=false;
      end;
        Except On EJclRegistryError do
      begin
        imgdisablehints.Picture.Bitmap.LoadFromResourceName(0, 'CROSS');
        imgdisablehints.Tag:=0;
        optionsfrm.ShowHint:=true;
        mainfrm.ShowHint:=true;
        toolsfrm.ShowHint:=true;
      end;
  end;

  //System Tray
  try
    if regreadinteger(HKEY_CURRENT_USER,'Software\Quick And Easy\ScummVM','systemtray')=0 then
      begin
        imgSystemTray.Picture.Bitmap.LoadFromResourceName(0, 'CROSS');
        imgSystemTray.Tag:=0;
        mainfrm.TrayIcon.Active:=false;
      end;
        Except On EJclRegistryError do
      begin
        imgSystemTray.Picture.Bitmap.LoadFromResourceName(0, 'TICK');
        imgSystemTray.Tag:=1;
        mainfrm.TrayIcon.Active:=true;
      end;
  end;

  //Splash Screen
  try
    if regreadinteger(HKEY_CURRENT_USER,'Software\Quick And Easy\ScummVM','splashscreen')=1 then
      begin
        imgdisablesplash.Picture.Bitmap.LoadFromResourceName(0, 'TICK');
        imgdisablesplash.Tag:=1;
      end;
        Except On EJclRegistryError do
      begin
        imgdisablesplash.Picture.Bitmap.LoadFromResourceName(0, 'CROSS');
        imgdisablesplash.Tag:=0;
      end;
  end;

  //Minimize On Run
  try
    if regreadinteger(HKEY_CURRENT_USER,'Software\Quick And Easy\ScummVM','minimizeonrun')=1 then
      begin
        imgminimize.Picture.Bitmap.LoadFromResourceName(0, 'TICK');
        imgminimize.Tag:=1;
      end;
        Except On EJclRegistryError do
      begin
        imgminimize.Picture.Bitmap.LoadFromResourceName(0, 'CROSS');
        imgminimize.Tag:=0;
      end;
  end;

  //Hide Console Window
  try
    if regreadinteger(HKEY_CURRENT_USER,'Software\Quick And Easy\ScummVM','hideconsolewindow')=1 then
      begin
        imghidewindow.Picture.Bitmap.LoadFromResourceName(0, 'TICK');
        imghidewindow.Tag:=1;
      end;
        Except On EJclRegistryError do
      begin
        imghidewindow.Picture.Bitmap.LoadFromResourceName(0, 'CROSS');
        imghidewindow.Tag:=0;
      end;
  end;

  //Fullscreen
  try
    if regreadinteger(HKEY_CURRENT_USER,'Software\Quick And Easy\ScummVM','defaultfullscreen')=1 then
      begin
        imgFullscreen.Picture.Bitmap.LoadFromResourceName(0, 'TICK');
        imgFullscreen.Tag:=1;
      end;
        Except On EJclRegistryError do
      begin
        imgFullscreen.Picture.Bitmap.LoadFromResourceName(0, 'CROSS');
        imgFullscreen.Tag:=0;
      end;
  end;

  //Aspect Ratio
  try
    if regreadinteger(HKEY_CURRENT_USER,'Software\Quick And Easy\ScummVM','defaultaspectratio')=0 then
      begin
        imgAspectRatio.Picture.Bitmap.LoadFromResourceName(0, 'CROSS');
        imgAspectRatio.Tag:=0;
      end;
        Except On EJclRegistryError do
      begin
        imgAspectRatio.Picture.Bitmap.LoadFromResourceName(0, 'TICK');
        imgAspectRatio.Tag:=1;
      end;
  end;

  //Subtitles
  try
    if regreadinteger(HKEY_CURRENT_USER,'Software\Quick And Easy\ScummVM','defaultsubtitles')=0 then
      begin
        imgSubtitles.Picture.Bitmap.LoadFromResourceName(0, 'CROSS');
        imgSubtitles.Tag:=0;
      end;
        Except On EJclRegistryError do
      begin
        imgSubtitles.Picture.Bitmap.LoadFromResourceName(0, 'TICK');
        imgSubtitles.Tag:=1;
      end;
  end;

  //Font
  try
    begin
      comboboxfont.FontName:=regreadstring(HKEY_CURRENT_USER,'Software\Quick And Easy\ScummVM','font');
      mainfrm.Font.Name:=regreadstring(HKEY_CURRENT_USER,'Software\Quick And Easy\ScummVM','font');
      toolsfrm.Font.Name:=regreadstring(HKEY_CURRENT_USER,'Software\Quick And Easy\ScummVM','font');
      optionsfrm.Font.Name:=regreadstring(HKEY_CURRENT_USER,'Software\Quick And Easy\ScummVM','font');
      editfrm.Font.Name:=regreadstring(HKEY_CURRENT_USER,'Software\Quick And Easy\ScummVM','font');
      if assigned(tasksfrm) then tasksfrm.Font.Name:=regreadstring(HKEY_CURRENT_USER,'Software\Quick And Easy\ScummVM','font');
      lblgeneral.Font.Name:=regreadstring(HKEY_CURRENT_USER,'Software\Quick And Easy\ScummVM','font');
      lblDefault.Font.Name:=regreadstring(HKEY_CURRENT_USER,'Software\Quick And Easy\ScummVM','font');
    end;

  Except On EJclRegistryError do
    begin
      comboboxfont.fontname:='Tahoma';
      mainfrm.Font.Name:='Tahoma';
      toolsfrm.Font.Name:='Tahoma';
      optionsfrm.Font.Name:='Tahoma';
      editfrm.Font.Name:='Tahoma';
      if assigned(tasksfrm) then tasksfrm.Font.Name:='Tahoma';
      lblgeneral.Font.Name:='Tahoma';
      lblDefault.Font.Name:='Tahoma';
    end;
  end;

  //Ini Path
  try
    begin
      editIniPath.Text:=regreadstring(HKEY_CURRENT_USER,'Software\Quick And Easy\ScummVM','inipath');
    end;

  Except On EJclRegistryError do
    begin
      editIniPath.Text:=GetWindowsFolder;
    end;
  end;

  //Savegame Path
  editSavePath.Text:=IniReadString(editIniPath.Text + '\' + 'Scummvm.ini', 'ScummVM', 'savepath');
  if editSavePath.Text='' then editSavePath.Text:='Current Directory';
    

  //Graphics Filter
  try
    comboboxgraphics.ItemIndex:=regreadinteger(HKEY_CURRENT_USER,'Software\Quick And Easy\ScummVM','defaultgraphicsfilter')
  Except On EJclRegistryError do
    comboboxgraphics.ItemIndex:=6
  end;
  
end;

procedure TOptionsfrm.lblFontMouseEnter(Sender: TObject);
begin
  lblFont.Font.style:=[fsunderline];
end;

procedure TOptionsfrm.lblFontMouseLeave(Sender: TObject);
begin
  lblFont.Font.style:=[];
end;

procedure TOptionsfrm.lblFontClick(Sender: TObject);
begin
  mainfrm.Font.Name:='Tahoma';
  toolsfrm.Font.Name:='Tahoma';
  optionsfrm.Font.Name:='Tahoma';
  editfrm.Font.Name:='Tahoma';
  if assigned(tasksfrm) then tasksfrm.Font.Name:='Tahoma';
  comboboxfont.Font.Name:='Tahoma';
  comboboxfont.FontName:='Tahoma';
  regwritestring(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'font', 'Tahoma');
end;

procedure TOptionsfrm.lblaspectratioMouseEnter(Sender: TObject);
begin
  lblaspectratio.Font.style:=[fsunderline];
end;

procedure TOptionsfrm.lblaspectratioMouseLeave(Sender: TObject);
begin
  lblaspectratio.Font.style:=[];
end;

procedure TOptionsfrm.lblaspectratioClick(Sender: TObject);
begin
  if imgAspectRatio.Tag=1 then
  begin
    imgAspectRatio.Picture.Bitmap.LoadFromResourceName(0,'CROSS');
    imgAspectRatio.Tag:=0;
    imgAspectRatio.Picture.Bitmap.FreeImage;
    regwriteinteger(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'defaultaspectratio', 0);
  end
  else
  begin
    imgAspectRatio.Picture.Bitmap.LoadFromResourceName(0,'TICK');
    imgAspectRatio.Tag:=1;
    imgAspectRatio.Picture.Bitmap.FreeImage;
    regwriteinteger(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'defaultaspectratio', 1);
  end;
end;

procedure TOptionsfrm.lblfullscreenClick(Sender: TObject);
begin
  if imgFullscreen.Tag=1 then
  begin
    imgFullscreen.Picture.Bitmap.LoadFromResourceName(0,'CROSS');
    imgFullscreen.Tag:=0;
    imgFullscreen.Picture.Bitmap.FreeImage;
    regwriteinteger(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'defaultfullscreen', 0);
  end
  else
  begin
    imgFullscreen.Picture.Bitmap.LoadFromResourceName(0,'TICK');
    imgFullscreen.Tag:=1;
    imgFullscreen.Picture.Bitmap.FreeImage;
    regwriteinteger(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'defaultfullscreen', 1);
  end;
end;

procedure TOptionsfrm.lblfullscreenMouseEnter(Sender: TObject);
begin
  lblFullscreen.Font.style:=[fsunderline];
end;

procedure TOptionsfrm.lblfullscreenMouseLeave(Sender: TObject);
begin
  lblFullscreen.Font.style:=[];
end;

procedure TOptionsfrm.lblsubtitlesClick(Sender: TObject);
begin
  if imgSubtitles.Tag=1 then
  begin
    imgSubtitles.Picture.Bitmap.LoadFromResourceName(0,'CROSS');
    imgSubtitles.Tag:=0;
    imgSubtitles.Picture.Bitmap.FreeImage;
    regwriteinteger(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'defaultsubtitles', 0);
  end
  else
  begin
    imgSubtitles.Picture.Bitmap.LoadFromResourceName(0,'TICK');
    imgSubtitles.Tag:=1;
    imgSubtitles.Picture.Bitmap.FreeImage;
    regwriteinteger(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'defaultsubtitles', 1);
  end;
end;

procedure TOptionsfrm.lblsubtitlesMouseEnter(Sender: TObject);
begin
  lblSubtitles.Font.style:=[fsunderline];
end;

procedure TOptionsfrm.lblsubtitlesMouseLeave(Sender: TObject);
begin
  lblSubtitles.Font.style:=[];
end;

procedure TOptionsfrm.lblDefaultMouseEnter(Sender: TObject);
begin
  lblDefault.Font.style:=[fsunderline, fsbold];
end;

procedure TOptionsfrm.lblDefaultMouseLeave(Sender: TObject);
begin
  lblDefault.Font.style:=[fsbold];
end;

procedure TOptionsfrm.JvBevel1MouseEnter(Sender: TObject);
begin
  lblDefault.Font.style:=[fsunderline];
end;

procedure TOptionsfrm.JvBevel1MouseLeave(Sender: TObject);
begin
  lblDefault.Font.style:=[];
end;

procedure TOptionsfrm.lblBalloonHintMouseEnter(Sender: TObject);
begin
  lblBalloonHint.Font.Style:=[fsunderline];
end;

procedure TOptionsfrm.lblBalloonHintMouseLeave(Sender: TObject);
begin
  lblBalloonHint.Font.Style:=[];
end;

procedure TOptionsfrm.lblBalloonHintClick(Sender: TObject);
begin
  if imgBalloonHint.Tag=1 then
  begin
    imgBalloonHint.Picture.Bitmap.LoadFromResourceName(0,'CROSS');
    imgBalloonHint.Tag:=0;
    imgBalloonHint.Picture.Bitmap.FreeImage;
    regwriteinteger(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'balloonhint', 0);
    mainfrm.BalloonHint.UseBalloonAsApplicationHint:=false;
  end
  else
  begin
    imgBalloonHint.Picture.Bitmap.LoadFromResourceName(0,'TICK');
    imgBalloonHint.Tag:=1;
    imgBalloonHint.Picture.Bitmap.FreeImage;
    regwriteinteger(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'balloonhint', 1);
    mainfrm.BalloonHint.UseBalloonAsApplicationHint:=true;
  end;
end;

procedure TOptionsfrm.lblBalloonHeaderMouseEnter(Sender: TObject);
begin
  lblBalloonHeader.Font.Style:=[fsunderline];
end;

procedure TOptionsfrm.lblBalloonHeaderMouseLeave(Sender: TObject);
begin
  lblBalloonHeader.Font.Style:=[];
end;

procedure TOptionsfrm.lblBalloonHeaderClick(Sender: TObject);
begin
  if imgBalloonHeader.Tag=1 then
  begin
    imgBalloonHeader.Picture.Bitmap.LoadFromResourceName(0,'CROSS');
    imgBalloonHeader.Tag:=0;
    imgBalloonHeader.Picture.Bitmap.FreeImage;
    mainfrm.BalloonHint.ApplicationHintOptions:=[];
    regwriteinteger(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'balloonheader', 0);
  end
  else
  begin
    imgBalloonHeader.Picture.Bitmap.LoadFromResourceName(0,'TICK');
    imgBalloonHeader.Tag:=1;
    imgBalloonHeader.Picture.Bitmap.FreeImage;
    mainfrm.BalloonHint.ApplicationHintOptions:=[ahShowHeaderInHint, ahShowIconInHint];
    regwriteinteger(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'balloonheader', 1);
  end;
end;

procedure TOptionsfrm.lblDisableHintsMouseEnter(Sender: TObject);
begin
  lblDisableHints.Font.Style:=[fsunderline];
end;

procedure TOptionsfrm.lblDisableHintsMouseLeave(Sender: TObject);
begin
  lblDisableHints.Font.Style:=[];
end;

procedure TOptionsfrm.lblDisableHintsClick(Sender: TObject);
begin
  if imgDisableHints.Tag=1 then
  begin
    imgDisableHints.Picture.Bitmap.LoadFromResourceName(0,'CROSS');
    imgDisableHints.Tag:=0;
    imgDisableHints.Picture.Bitmap.FreeImage;
    optionsfrm.ShowHint:=true;
    mainfrm.ShowHint:=true;
    toolsfrm.ShowHint:=true;
    regwriteinteger(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'disablehints', 0);
  end
  else
  begin
    imgDisableHints.Picture.Bitmap.LoadFromResourceName(0,'TICK');
    imgDisableHints.Tag:=1;
    imgDisableHints.Picture.Bitmap.FreeImage;
    optionsfrm.ShowHint:=false;
    mainfrm.ShowHint:=false;
    toolsfrm.ShowHint:=false;
    regwriteinteger(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'disablehints', 1);
  end;
end;

procedure TOptionsfrm.lblSystemTrayMouseEnter(Sender: TObject);
begin
  lblsystemtray.Font.Style:=[fsunderline];
end;

procedure TOptionsfrm.lblSystemTrayMouseLeave(Sender: TObject);
begin
  lblSystemTray.Font.Style:=[];
end;

procedure TOptionsfrm.lblSystemTrayClick(Sender: TObject);
begin
  if imgSystemTray.Tag=1 then
  begin
    imgSystemTray.Picture.Bitmap.LoadFromResourceName(0,'CROSS');
    imgSystemTray.Tag:=0;
    imgSystemTray.Picture.Bitmap.FreeImage;
    mainfrm.TrayIcon.Active:=false;
    regwriteinteger(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'systemtray', 0);
  end
  else
  begin
    imgSystemTray.Picture.Bitmap.LoadFromResourceName(0,'TICK');
    imgSystemTray.Tag:=1;
    imgSystemTray.Picture.Bitmap.FreeImage;
    mainfrm.TrayIcon.Active:=true;
    regwriteinteger(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'systemtray', 1);
  end;
end;

procedure TOptionsfrm.lblDisableSplashMouseEnter(Sender: TObject);
begin
  lblDisableSplash.Font.Style:=[fsunderline];
end;

procedure TOptionsfrm.lblDisableSplashMouseLeave(Sender: TObject);
begin
  lblDisableSplash.Font.Style:=[];
end;

procedure TOptionsfrm.lblDisableSplashClick(Sender: TObject);
begin
  if imgDisableSplash.Tag=1 then
  begin
    imgDisableSplash.Picture.Bitmap.LoadFromResourceName(0,'CROSS');
    imgDisableSplash.Tag:=0;
    imgDisableSplash.Picture.Bitmap.FreeImage;
    regwriteinteger(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'splashscreen', 0);
  end
  else
  begin
    imgDisableSplash.Picture.Bitmap.LoadFromResourceName(0,'TICK');
    imgDisableSplash.Tag:=1;
    imgDisableSplash.Picture.Bitmap.FreeImage;
    regwriteinteger(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'splashscreen', 1);
  end;
end;

procedure TOptionsfrm.lblDefaultClick(Sender: TObject);
begin
  regwriteinteger(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'defaultaspectratio', 1);
  imgAspectRatio.Picture.Bitmap.LoadFromResourceName(0,'TICK');
  imgAspectRatio.Tag:=1;

  regwriteinteger(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'defaultfullscreen', 0);
  imgFullscreen.Picture.Bitmap.LoadFromResourceName(0,'CROSS');
  imgFullscreen.Tag:=0;
  
  regwriteinteger(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'defaultsubtitles', 1);
  imgSubtitles.Picture.Bitmap.LoadFromResourceName(0,'TICK');
  imgSubtitles.Tag:=1;

  regwriteinteger(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'defaultgraphicsfilter', 6);
  comboboxgraphics.ItemIndex:=6;
end;

procedure TOptionsfrm.comboboxgraphicsChange(Sender: TObject);
begin
  regwriteinteger(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'defaultgraphicsfilter', comboboxgraphics.ItemIndex);
end;

procedure TOptionsfrm.lblIniPathMouseEnter(Sender: TObject);
begin
  lblinipath.Font.style:=[fsunderline];
end;

procedure TOptionsfrm.lblIniPathMouseLeave(Sender: TObject);
begin
  lblinipath.Font.style:=[];
end;

procedure TOptionsfrm.btnIniBrowseClick(Sender: TObject);
var
  St: string;
begin
  St:=editinipath.Text;
  if selectdirectory ('Select the folder where the alternate ScummVM.ini is located','',St) then Editinipath.Text:=StrEnsureSuffix(#92, St);
end;

procedure TOptionsfrm.lblIniPathClick(Sender: TObject);
begin
  editinipath.Text:=GetWindowsFolder;
end;

procedure TOptionsfrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //Write Ini Path
  if directoryexists(editIniPath.Text) then
    regwritestring(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'inipath', editIniPath.Text)
  else
  begin
    regwritestring(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'inipath', getwindowsfolder);
    editIniPath.Text:=getWindowsFolder;
  end;

  //Write Savegame Path
  try
    if directoryexists(editSavePath.Text) then
      iniwritestring(editIniPath.Text + '\' + 'ScummVM.ini', 'ScummVM', 'savepath', editSavePath.Text)
    else
    begin
      iniwritestring(editIniPath.Text + '\' + 'ScummVM.ini', 'ScummVM', 'savepath', '');
      editSavePath.Text:='Current Directory';
    end;
    except on einifileexception do
      editSavePath.Text:='Current Directory';
  end;
end;

procedure TOptionsfrm.lblSavePathMouseEnter(Sender: TObject);
begin
  lblSavePath.Font.style:=[fsunderline];
end;

procedure TOptionsfrm.lblSavePathMouseLeave(Sender: TObject);
begin
  lblSavePath.Font.style:=[];
end;

procedure TOptionsfrm.lblSavePathClick(Sender: TObject);
begin
  editSavePath.Text:='Current Directory';
end;

procedure TOptionsfrm.btnSavePathClick(Sender: TObject);
var
  St: string;
begin
  St:=editinipath.Text;
  if selectdirectory ('Select the folder where savegames are stored.','',St) then Editsavepath.Text:=StrEnsureSuffix(#92, St);
end;

procedure TOptionsfrm.lblPathMouseEnter(Sender: TObject);
begin
  lblPath.Font.style:=[fsunderline, fsbold];
end;

procedure TOptionsfrm.lblPathMouseLeave(Sender: TObject);
begin
  lblPath.Font.style:=[fsbold];
end;

procedure TOptionsfrm.lblPathClick(Sender: TObject);
begin
  editSavePath.Text:='Current Directory';
  editinipath.Text:=GetWindowsFolder;
end;

procedure TOptionsfrm.lblMinimizeMouseEnter(Sender: TObject);
begin
  lblMinimize.Font.Style:=[fsunderline];
end;

procedure TOptionsfrm.lblMinimizeMouseLeave(Sender: TObject);
begin
  lblMinimize.Font.Style:=[];
end;

procedure TOptionsfrm.lblMinimizeClick(Sender: TObject);
begin
  if imgminimize.Tag=1 then
  begin
    imgminimize.Picture.Bitmap.LoadFromResourceName(0,'CROSS');
    imgminimize.Tag:=0;
    imgminimize.Picture.Bitmap.FreeImage;
    regwriteinteger(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'minimizeonrun', 0);
  end
  else
  begin
    imgminimize.Picture.Bitmap.LoadFromResourceName(0,'TICK');
    imgminimize.Tag:=1;
    imgminimize.Picture.Bitmap.FreeImage;
    regwriteinteger(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'minimizeonrun', 1);
  end;
end;

procedure TOptionsfrm.lblHideWindowMouseEnter(Sender: TObject);
begin
  lblHideWindow.Font.Style:=[fsunderline];
end;

procedure TOptionsfrm.lblHideWindowMouseLeave(Sender: TObject);
begin
  lblHideWindow.Font.Style:=[];
end;

procedure TOptionsfrm.lblHideWindowClick(Sender: TObject);
begin
  if imghidewindow.Tag=1 then
  begin
    imghidewindow.Picture.Bitmap.LoadFromResourceName(0,'CROSS');
    imghidewindow.Tag:=0;
    imghidewindow.Picture.Bitmap.FreeImage;
    regwriteinteger(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'hideconsolewindow', 0);
  end
  else
  begin
    imghidewindow.Picture.Bitmap.LoadFromResourceName(0,'TICK');
    imghidewindow.Tag:=1;
    imghidewindow.Picture.Bitmap.FreeImage;
    regwriteinteger(HKEY_CURRENT_USER, 'Software\Quick And Easy\ScummVM', 'hideconsolewindow', 1);
  end;
end;

end.
